// JMM5000ConsoleApplication.cpp : Defines the entry point for the console application.
//

//#include "stdafx.h"
#include "JMM5000.h"
#include <math.h>

#include "stdlib.h"

char input_buffer[100];
void Output_Control();
void Read_Voltage_Current_Power();
void Power_Duty_Cycle_Control();
void Input_voltage_Range_Selection();
void LED_Control();
void Write_LTC2974();
void Read_LTC2974();
void Firmware_Version();
void Reset();
void Write_potentiometer();
void Nominal_Resistance();
void Bytewrite();
void Byteread();
void disable_Temp_limit();

int main(int argc, char* argv[])
{
	int Option = 0 ;
	
	printf("\nJMM5000 Configuration Test Program\n\n");

	if (JMM5000_Init()!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000 Init error : %s\n",error.error_string);
		return 0;
	}

	do 
	{
		printf("\nPlease select one of the following options:\n");
		printf("===============================================\n");
		printf("1)  Output Control\n");
		printf("2)  Read Output voltage,Current and Power\n");
		printf("3)  Power duty cycle\n");
		printf("4)  Input voltage range selection\n");
		printf("5)  LED Control\n");
		printf("6)  Write to LTC2974\n");
		printf("7)  Read from LTC2974\n");
		printf("8)  Read Firmware version\n");
		printf("9)  Write to Potentiometer\n");
		printf("10) Reset the board\n");
		printf("11) Byte Write \n");
		printf("12) Disable OT&UT limit \n");
		printf("q)  Exit\n");
		printf("===============================================\n");
		fgets(input_buffer,100,stdin);
		sscanf(input_buffer,"%d",&Option);

		if(input_buffer[0]=='q')
		{
			Option='q';
		}

		switch(Option)
		{
		case 1:
				Output_Control();
				break;
		case 2:
				Read_Voltage_Current_Power();
				break;
		case 3:
				Power_Duty_Cycle_Control();				
				break;
		case 4:
				Input_voltage_Range_Selection();
				break;
		case 5:
				LED_Control();
				break;
		case 6:
				Write_LTC2974();
				break;
		case 7:
				Read_LTC2974();
				break;
		case 8:
			    Firmware_Version();
				break;
		case 9:
				Write_potentiometer();
				break;  
		case 10:
			   Reset();
			   break;
			   
		case 11:
			   Bytewrite();
			   break;
			   
 	    case 12:
			   disable_Temp_limit();
			   break;
			   
		case 'q':
				break;
		default :
				printf("Invalid option selected \n");
		}

	}while (Option !='q');
	
	JMM5000_Close();
	return 0;
}

void disable_Temp_limit()
{
	int command =0,data=0,page_enable=0;
	unsigned char page=0x0;

	page_enable=1;
	command=0x50;
	page=0;
	data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
	page_enable=1;
	command=0x50;
	page=1;
	data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
	page_enable=1;
	command=0x50;
	page=2;
	data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
	page_enable=1;
	command=0x50;
	page=3;
	data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
	page_enable=1;
	command=0x54;
	page=0;
	data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
	page_enable=1;
	command=0x54;
	page=1;
	data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
	page_enable=1;
	command=0x54;
	page=2;
	data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
	page_enable=1;
	command=0x54;
	page=3;
	data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
	page_enable=0;
	command=0x15;
	//data=0;
	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
}

void Nominal_Resistance()
{
	int resistance=0,page=0;
	float value[3];
	
	printf("Enter the nominal resistance for 12V in milli ohms:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%f",&value[0]);
	
	printf("Enter the nominal resistance for 5V in milli ohms:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%f",&value[1]);

	printf("Enter the nominal resistance for 3.3V in milli ohms:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%f",&value[2]);
	
	for(page=0;page<3;page++)
	{
		JMM5000_Double_To_L11(value[page],&resistance);
		
		if(JMM5000_ControlWrite(0x38,1,page,resistance) !=0)
		{
			DSCGetLastError(&error);
			printf("JMM5000 ControlWrite error : %s\n",error.error_string);
			#ifdef WIN32
			return ;
			#else
			exit(0);
			#endif
		}
	}

}


void Write_potentiometer()
{
	unsigned char control=0,data=0;
	printf("This option enables direct control of the trimpot that manages the input voltagelimits.\n");
	printf("Enter the control byte (Hex):");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&control);

	printf("Enter the data byte (Hex):");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&data);

	JMM5000_InputConfigStore(control,data);
}
void Reset()
{
	//JMM5000_ResetPIC();
	JMM5000_ResetControl();
	printf("\nBoard Reset is Done.");
}
void Firmware_Version()
{
	unsigned char Request_Status[4];
    char buffer[20];
	JMM5000_Status(Request_Status);
    sprintf(buffer,"%d.0%d",Request_Status[1],Request_Status[0]);
	printf("Firmware Version: %s\n",buffer);
}
void Output_Control()
{
	int data = 0 , temp = 0;
	printf("Control 5V output (0-Disable , 1- Enable ) Default-1 :");
	fgets(input_buffer,100,stdin);
	if(input_buffer[0]=='\n')
	{
		temp=1;
	}
	else
	{
		sscanf(input_buffer,"%d",&temp);
	}
	data =  temp ; 

	printf("Control 12V output (0-Disable , 1- Enable ) Default-1 :");
	fgets(input_buffer,100,stdin);
	if(input_buffer[0]=='\n')
	{
		temp=1;
	}
	else
	{
		sscanf(input_buffer,"%d",&temp);
	}
	data |=  (temp<<2) ; 

	if(data & 0x01)
	{
		printf("Control 3.3V output (0-Disable , 1- Enable ) Default-1 :");
		fgets(input_buffer,100,stdin);
		if(input_buffer[0]=='\n')
		{
			temp=1;
		}
		else
		{
			sscanf(input_buffer,"%d",&temp);
		}
		data |=  (temp<<3) ;
	}
	else
	{
		printf("\n3.3V cannot be controlled when 5V is not enabled");
	}

	if(JMM5000_PowerControl(data) !=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000 PowerControl error : %s\n",error.error_string);
		#ifdef WIN32
		return ;
		#else
		exit(0);
		#endif
	}
}

void Read_Voltage_Current_Power()
{
	
	JMM5000_OutputStatus(&getvalues);

	printf("=====================================================\n");
	printf("\t12V\t5V\t3.3V\n");
	printf("Voltage %02.4lf\t%02.4lf\t%02.4lf\t\n",getvalues.Voltage[0],getvalues.Voltage[1],getvalues.Voltage[2]);
	printf("Current %02.4lf\t%02.4lf\t%02.4lf\t\n",getvalues.Current[0],getvalues.Current[1],getvalues.Current[2]);
	printf("Power   %02.4lf\t%02.4lf\t%02.4lf\t\n",getvalues.Power[0],getvalues.Power[1],getvalues.Power[2]);
   	printf("=====================================================\n");
}

void Power_Duty_Cycle_Control()
{
	int value = 0 ;
	char data = 0;
	printf("Select outputs that will be controlled with the power cycle timer");

	printf("Control 5V (0-Disable ,1-Enable) Default-1 :");
	fgets(input_buffer,100,stdin);
	if(input_buffer[0]=='\n')
	{
		value=1;
	}
	else
	{
		sscanf(input_buffer,"%d",&value);
	}
	data=value;

	printf("Control 12V (0-Disable ,1-Enable) Default-1 :");
	fgets(input_buffer,100,stdin);
	if(input_buffer[0]=='\n')
	{
		value=1;
	}
	else
	{
		sscanf(input_buffer,"%d",&value);
	}
	data |=(value<<2);

	if( data & 0x01)
	{
		printf("Control 3.3V (0-Disable ,1-Enable) Default-1 :");
		fgets(input_buffer,100,stdin);
		if(input_buffer[0]=='\n')
		{
			value=1;
		}
		else
		{
			sscanf(input_buffer,"%d",&value);
		}
		data |=(value<<3);
	}
	else
	{
		printf("\n3.3V cannot be controlled when 5V is not enabled");
	}

	if(JMM5000_PowerCycleControl(data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000 PowerCycleControl error : %s\n",error.error_string);
		#ifdef WIN32
		return ;
		#else
		exit(0);
		#endif
	}

	printf("Enter period of Power cycle timer in seconds (Maximum : 131070 seconds (36 hours) ) Default-600:");
	fgets(input_buffer,100,stdin);
	if(input_buffer[0]=='\n')
	{
		value=600;
	}
	else
	{
		sscanf(input_buffer,"%d",&value);
	}
	value=value/2;
	if(JMM5000_PowerCycleTime(value)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000 PowerCycleTime error : %s\n",error.error_string);
		#ifdef WIN32
		return ;
		#else
		exit(0);
		#endif
	}
	printf("Enter length of time the selected outputs will remain on each time a power-on cycle occurs in seconds (Maximum : 131070 seconds (36 hours) ) Default-30:");
	fgets(input_buffer,100,stdin);
	if(input_buffer[0]=='\n')
	{
		value=30;
	}
	else
	{
		sscanf(input_buffer,"%d",&value);
	}
	if(JMM5000_PowerOnTime(value)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000 PowerOnTime error : %s\n",error.error_string);
		#ifdef WIN32
		return ;
		#else
		exit(0);
		#endif
	}

}

void Input_voltage_Range_Selection()
{
	float LowerVoltage = 0, UpperVoltage= 0;
	int value=0;

	printf("Enter the selection, 1-primary 2-secondary voltage Default-1:"); 
	fgets(input_buffer,100,stdin);
	if(input_buffer[0]=='\n')
	{
		value=1;
	}
	else
	{
		sscanf(input_buffer,"%d",&value);
	}

	if(value==1)
	{
		printf("Enter primary input low voltage limit (7V-34V) Default-7V:"); 
		fgets(input_buffer,100,stdin);
		if(input_buffer[0]=='\n')
		{
			LowerVoltage=7;
		}
		else
		{
			sscanf(input_buffer,"%f",&LowerVoltage);
		}
		if(LowerVoltage==7.0)
		{
			LowerVoltage=6.8;
		}
		
		printf("Enter primary input high voltage limit (7V-34V) Default-34V:"); 
		fgets(input_buffer,100,stdin);
		if(input_buffer[0]=='\n')
		{
			UpperVoltage=34;
		}
		else
		{
			sscanf(input_buffer,"%f",&UpperVoltage);
		}
		
	}
	else if(value==2)
	{
		printf("Enter secondary input low voltage limit (7V-34V) Default-7V:"); 
		fgets(input_buffer,100,stdin);
		if(input_buffer[0]=='\n')
		{
			LowerVoltage=7;
		}
		else
		{
			sscanf(input_buffer,"%f",&LowerVoltage);
		}
		if(LowerVoltage==7.0)
		{
			LowerVoltage=6.8;
		}

		printf("Enter secondary input high voltage limit (7V-34V) Default-34V:"); 
		fgets(input_buffer,100,stdin);
		if(input_buffer[0]=='\n')
		{
			UpperVoltage=34;
		}
		else
		{
			sscanf(input_buffer,"%f",&UpperVoltage);
		}
	} 
	
	if(JMM5000_InputConfig(value,LowerVoltage ,UpperVoltage) !=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_InputConfig error : %s\n",error.error_string);
		#ifdef WIN32
		return ;
		#else
		exit(0);
		#endif
	}

	return ;
	
}

void LED_Control()
{
	int value = 0 ;
	printf("Control user LED (1-Turn ON, 0-Turn OFF) Default-1:");
	fgets(input_buffer,100,stdin);
	if(input_buffer[0]=='\n')
	{
			value=1;
	}
	else
	{
		sscanf(input_buffer,"%d",&value);
	}
	

	if(JMM5000_LED(value)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_LED error : %s\n",error.error_string);
		#ifdef WIN32
		return ;
		#else
		exit(0);
		#endif
	}
}

void Bytewrite()
{
	int command =0,data=0,page_enable=0;
	unsigned char page=0x0;
  
	printf("\nCommand is page enable (1:Page Enabled,0:Not Page Enabled refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&page_enable);

	if(page_enable==1)
	{
		printf("\nEnter page number in Hex (page values are specific to LTC2974, refer data sheet:");
		fgets(input_buffer,100,stdin);
		sscanf(input_buffer,"%x",&page);
	}

	printf("\nEnter command in Hex (cmd values are specific to LTC2974, refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&command);

	printf("\nEnter data value in Hex (Data values are specific to LTC2974, refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&data);

	if(JMM5000_BYTE_Write(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s",error.error_string);
		return ;
	}
	
}

void  Write_LTC2974()
{
	int command =0,data=0,page_enable=0;
	unsigned char page=0x0;
  
	printf("\nCommand is page enable (1:Page Enabled,0:Not Page Enabled refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&page_enable);

	if(page_enable==1)
	{
		printf("\nEnter page number in Hex (page values are specific to LTC2974, refer data sheet:");
		fgets(input_buffer,100,stdin);
		sscanf(input_buffer,"%x",&page);
	}

	printf("\nEnter command in Hex (cmd values are specific to LTC2974, refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&command);

	printf("\nEnter data value in Hex (Data values are specific to LTC2974, refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&data);

	if(JMM5000_ControlWrite(command,page_enable,page,data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlWrite error : %s\n",error.error_string);
		#ifdef WIN32
		return ;
		#else
		exit(0);
		#endif
	}

}

void Byteread()
{
	int command =0;
	int data  =0 ,page_enable=0;
	unsigned char page=0x0;

	printf("\nCommand is page enable (1:Page Enabled,0:Not Page Enabled refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&page_enable);

	if(page_enable==1)
	{
		printf("Enter page number in Hex (page values are specific to LTC2974, refer data sheet:");
		fgets(input_buffer,100,stdin);
		sscanf(input_buffer,"%x",&page);
	}

	printf("Enter command in Hex (cmd values are specific to LTC2974, refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&command);

	if(JMM5000_Byte_ControlRead(command,page_enable,page,&data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlRead error : %s",error.error_string);
		return ;
	}

	printf("Read value : 0x%x \n",data);

}

void Read_LTC2974()
{
	int command =0;
	int data  =0 ,page_enable=0;
	unsigned char page=0x0;

	printf("\nCommand is page enable (1:Page Enabled,0:Not Page Enabled refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&page_enable);

	if(page_enable==1)
	{
		printf("Enter page number in Hex (page values are specific to LTC2974, refer data sheet:");
		fgets(input_buffer,100,stdin);
		sscanf(input_buffer,"%x",&page);
	}

	printf("Enter command in Hex (cmd values are specific to LTC2974, refer data sheet:");
	fgets(input_buffer,100,stdin);
	sscanf(input_buffer,"%x",&command);

	if(JMM5000_ControlRead(command,page_enable,page,&data)!=0)
	{
		DSCGetLastError(&error);
		printf("JMM5000_ControlRead error : %s\n",error.error_string);
		#ifdef WIN32
		return ;
		#else
		exit(0);
		#endif
	}

	printf("Read value : 0x%x \n",data);

}
